#include "../Compression.h"
#include "libGRZip.h"

int grzip_compress   (int Method,
                      int BlockSize,
                      int EnableLZP,
                      int MinMatchLen,
                      int HashSizeLog,
                      int AlternativeBWTSort,
                      int AdaptiveBlockSize,
                      int DeltaFilter,
                      INOUT_FUNC *read_f,
                      INOUT_FUNC *write_f);

int grzip_decompress (int Method,
                      int BlockSize,
                      int EnableLZP,
                      int MinMatchLen,
                      int HashSizeLog,
                      int AlternativeBWTSort,
                      int AdaptiveBlockSize,
                      int DeltaFilter,
                      INOUT_FUNC *read_f,
                      INOUT_FUNC *write_f);


#ifdef __cplusplus

//      COMPRESSION_METHOD
class GRZIP_METHOD : public COMPRESSION_METHOD
{
public:
  //    
  int Method;
  int BlockSize;
  int EnableLZP;
  int MinMatchLen;
  int HashSizeLog;
  int AlternativeBWTSort;
  int AdaptiveBlockSize;
  int DeltaFilter;

  // ,       
  GRZIP_METHOD();

  //    
  virtual int decompress (INOUT_FUNC *read_f, INOUT_FUNC *write_f);
#ifndef FREEARC_DECOMPRESS_ONLY
  virtual int compress (INOUT_FUNC *read_f, INOUT_FUNC *write_f);

  //   buf[MAX_METHOD_STRLEN] ,       (,   parse_GRZIP)
  virtual void ShowCompressionMethod (char *buf);

  // /  ,   /,     
  virtual int  GetCompressionMem     (void)     {return BlockSize*9;}
  virtual int  GetDecompressionMem   (void)     {return BlockSize*5;}
  virtual int  GetDictionary         (void)     {return BlockSize;}
  virtual int  GetBlockSize          (void)     {return BlockSize;}
  virtual void SetCompressionMem     (int mem)  {if (mem>0)   BlockSize = mymin (mem/9, GRZ_MaxBlockSize);}
  virtual void SetDecompressionMem   (int mem)  {if (mem>0)   BlockSize = mymin (mem/5, GRZ_MaxBlockSize);}
  virtual void SetDictionary         (int dict) {if (dict>0)  BlockSize = mymin (dict,  GRZ_MaxBlockSize);}
  virtual void SetBlockSize          (int bs)   {if (bs>0)    BlockSize = mymin (bs,    GRZ_MaxBlockSize);}
#endif
};

//     GRZIP
COMPRESSION_METHOD* parse_GRZIP (char** parameters);

#endif  // __cplusplus
