#include <time.h>
#include <stdio.h>
#include <windows.h>
extern "C" {
#include "C_BCJ.h"
}

#include "7zip/Compress/Branch/BranchCoder.cpp"
#include "7zip/Compress/Branch/x86.cpp"

#ifndef FREEARC_DECOMPRESS_ONLY

int bcj_x86_compress( INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  CBCJ_x86_Encoder c; c.Init();         //   BCJ-X86 
  BYTE* Buf = new BYTE[BUFFER_SIZE];    //   
  int RemainderSize=0;                  //     
  int InSize;                           //   
  while ( (InSize = read_f( Buf+RemainderSize, BUFFER_SIZE-RemainderSize)) >= 0 )
  {
    if ((InSize+=RemainderSize)==0)            goto Ok;  //   
    int OutSize = InSize<=5? InSize : c.Filter(Buf, InSize);  //  5      :)
    if( write_f(Buf,OutSize) != OutSize )      goto Error;
    RemainderSize = InSize-OutSize;
    //       
    if (RemainderSize>0)                memmove(Buf,Buf+OutSize,RemainderSize);
  }
Error: delete Buf; return -1; //    /
Ok:    delete Buf; return 0;  //   
}

#endif  // !defined (FREEARC_DECOMPRESS_ONLY)

int bcj_x86_decompress( INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  CBCJ_x86_Decoder c; c.Init();         //   BCJ-X86 
  BYTE* Buf = new BYTE[BUFFER_SIZE];    //   
  int RemainderSize=0;                  //     
  int InSize;                           //   
  while ( (InSize = read_f( Buf+RemainderSize, BUFFER_SIZE-RemainderSize)) >= 0 )
  {
    if ((InSize+=RemainderSize)==0)            goto Ok;  //   
    int OutSize = InSize<=5? InSize : c.Filter(Buf, InSize);  //  5      :)
    if( write_f(Buf,OutSize) != OutSize )      goto Error;
    RemainderSize = InSize-OutSize;
    //       
    if (RemainderSize>0)                memmove(Buf,Buf+OutSize,RemainderSize);
  }
Error: delete Buf; return -1; //    /
Ok:    delete Buf; return 0;  //   
}


/*-------------------------------------------------*/
/*   BCJ_X86_METHOD                */
/*-------------------------------------------------*/
//  
int BCJ_X86_METHOD::decompress (INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  return bcj_x86_decompress (read_f, write_f);
}

#ifndef FREEARC_DECOMPRESS_ONLY

//  
int BCJ_X86_METHOD::compress (INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  return bcj_x86_compress (read_f, write_f);
}

//   buf[MAX_METHOD_STRLEN] ,    (,   parse_BCJ_X86)
void BCJ_X86_METHOD::ShowCompressionMethod (char *buf)
{
  sprintf (buf, "exe");
}

#endif  // !defined (FREEARC_DECOMPRESS_ONLY)

//    BCJ_X86_METHOD   NULL,     
COMPRESSION_METHOD* parse_BCJ_X86 (char** parameters)
{
  if (strcmp (parameters[0], "exe") == 0
      &&  parameters[1]==NULL )
    //    - "exe"     ,    
    return new BCJ_X86_METHOD;
  else
    return NULL;   //    bcj_x86
}

static int BCJ_X86_x = AddCompressionMethod (parse_BCJ_X86);   //    BCJ_X86
