#include "../Compression.h"

int lzma_compress   (int dictionarySize,
                     int algorithm,
                     int numFastBytes,
                     int matchFinder,
                     int posStateBits,
                     int litContextBits,
                     int litPosBits,
                     INOUT_FUNC *read_f,
                     INOUT_FUNC *write_f);

int lzma_decompress (int dictionarySize,
                     int algorithm,
                     int numFastBytes,
                     int matchFinder,
                     int posStateBits,
                     int litContextBits,
                     int litPosBits,
                     INOUT_FUNC *read_f,
                     INOUT_FUNC *write_f);


#ifdef __cplusplus

//      COMPRESSION_METHOD
class LZMA_METHOD : public COMPRESSION_METHOD
{
public:
  //    
  int dictionarySize;
  int algorithm;
  int numFastBytes;
  int matchFinder;
  int posStateBits;
  int litContextBits;
  int litPosBits;

  // ,       
  LZMA_METHOD();

  //    
  virtual int decompress (INOUT_FUNC *read_f, INOUT_FUNC *write_f);
#ifndef FREEARC_DECOMPRESS_ONLY
  virtual int compress (INOUT_FUNC *read_f, INOUT_FUNC *write_f);

  //   buf[MAX_METHOD_STRLEN] ,       (,   parse_LZMA)
  virtual void ShowCompressionMethod (char *buf);

  // /  ,   /,     
  virtual int  GetCompressionMem     (void);
  virtual int  GetDecompressionMem   (void)     {return dictionarySize;}
  virtual int  GetDictionary         (void)     {return dictionarySize;}
  virtual int  GetBlockSize          (void)     {return 0;}
  virtual void SetCompressionMem     (int mem);
  virtual void SetDecompressionMem   (int mem)  {if (mem>0)   dictionarySize = mem;}
  virtual void SetDictionary         (int dict) {if (dict>0)  dictionarySize = dict;}
  virtual void SetBlockSize          (int)      {}
#endif
};

//     LZMA
COMPRESSION_METHOD* parse_LZMA (char** parameters);

#endif  // __cplusplus
