#include <time.h>
#include <windows.h>
#include <stdio.h>
extern "C" {
#include "C_LZP.h"
}


/*                          tuned for PPMd
static const BYTE MO2MML[4] = {5,11,19,44};
static inline UINT GetMinMatchLen(UINT MaxOrder) {
    return (MaxOrder < 6)?(MO2MML[MaxOrder-2]):(CLAMP(10*MaxOrder-15,51,475));
}
*/
enum { LZP_MATCH_FLAG=0xB5 };

static inline UINT& lzpC (BYTE* p) { return *(UINT*)(p-4); }
static inline UINT  lzpH_(UINT  c) { return (c+5*(c >> 15)); }
#define             lzpH(c)        ( lzpH_(c) & (HashSize-1) )
#define LZP_INIT(HashSize,Pattern)                                          \
    UINT c, Len, HVal;                                                      \
    int k;                                                                  \
    BYTE* p, ** HTable = new BYTE*[HashSize];                               \
    for (HVal=0;HVal < HashSize;HVal++)     HTable[HVal]=Pattern+4;         \
    lzpC(Out+4)=lzpC(In+4);                 Out[4]=In[4];                   \
    c=lzpC(In += 5);                        Out += 5;

#ifndef FREEARC_DECOMPRESS_ONLY
int LZPEncode(BYTE* In,UINT Size,BYTE* Out,int MinLen,int HashSize)
{
    BYTE* InEnd=In+Size, * OutStart=Out, * OutEnd=Out+Size;
    LZP_INIT(HashSize,In);
    do {
        p=HTable[HVal=lzpH(c)];             HTable[HVal]=In;
        if (c != lzpC(p))                   *Out++ = *In++;
        else {
            Len=0;
            if (In+MinLen <= InEnd && lzpC(p+MinLen) == lzpC(In+MinLen))
                    while (In+Len < InEnd && In[Len] == p[Len])
                            Len++;
            if (Len >= MinLen) {
                *Out++ = LZP_MATCH_FLAG;    In += (k=Len);
                for (Len -= MinLen;Len >= 254;Len -= 254)
                        *--OutEnd = 0;
                *--OutEnd = Len+1;
                while ((k -= 5) > 0)        HTable[lzpH(lzpC(In-k))]=In-k;
            } else if ((*Out++ = *In++) == LZP_MATCH_FLAG)
                    *--OutEnd = 255;
        }
        c=lzpC(In);
    } while (In < InEnd);
    delete HTable;
    if (Out+256+(Size >> 7) > OutEnd)       return -1;
    memmove(Out,OutEnd,OutStart+Size-OutEnd);
    return Size-(OutEnd-Out);
}
#endif  // !defined (FREEARC_DECOMPRESS_ONLY)

int LZPDecode(BYTE* In,UINT Size,BYTE* Out,int MinLen,int HashSize)
{
    BYTE* InEnd=In+Size, * OutStart=Out;
    LZP_INIT(HashSize,Out);
    do {
        p=HTable[HVal=lzpH(c)];             HTable[HVal]=Out;
        if (c != lzpC(p))                   *Out++ = *In++;
        else if (*In++ != LZP_MATCH_FLAG)   *Out++ = In[-1];
        else if (*--InEnd != 255) {
            for (Len=MinLen-1;*InEnd == 0;InEnd--)
                    Len += 254;
            Len += *InEnd;                  k=6;
            do {
                if ( !--k ) { k=5;          HTable[lzpH(lzpC(Out))]=Out; }
                *Out++ = *p++;
            } while ( --Len );
        } else                              *Out++ = LZP_MATCH_FLAG;
        c=lzpC(Out);
    } while (In < InEnd);
    delete HTable;                          return (Out-OutStart);
}

#ifndef FREEARC_DECOMPRESS_ONLY
int lzp_compress (int BlockSize, int MinMatchLen, int HashSizeLog, INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  BYTE* In  = new BYTE[BlockSize+1];    //    
  BYTE* Out = new BYTE[BlockSize+1];    //    
  int InSize;                           //     
  while ( (InSize = read_f( In, BlockSize)) > 0 )
  {
    int OutSize = LZPEncode(In,InSize,Out,MinMatchLen,1<<HashSizeLog);
    BYTE *p; int WrSize, Size;
    if ( OutSize<0 )    p=In,  WrSize=-InSize, Size=InSize;    //    ,   
    else                p=Out, WrSize=OutSize, Size=OutSize;
    if( write_f(&WrSize,sizeof(WrSize))!=sizeof(WrSize) || write_f(p,Size)!=Size )
      { InSize=-1; break; } //     ,    /   
  }
  delete Out; delete In; return InSize;  // 0,    ,   ,       
}
#endif  // !defined (FREEARC_DECOMPRESS_ONLY)

int lzp_decompress (int BlockSize, int MinMatchLen, int HashSizeLog, INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  BYTE* In  = new BYTE[BlockSize+1];    //    
  BYTE* Out = new BYTE[BlockSize+1];    //    
  int x,InSize;                         //     
  for(;;)
  {
    if( (x=read_f( &InSize, sizeof(InSize))) != sizeof(InSize))
       if (x==0) goto Ok; else                               goto Error;
    if( InSize<0 )
    {
      InSize = -InSize;    //   
      if( (x=read_f ( In, InSize)) != InSize )               goto Error;
      if( (x=write_f( In, InSize)) != InSize )               goto Error;
    } else {
      if( (x=read_f ( In, InSize)) != InSize )               goto Error;
      int OutSize = LZPDecode(In,InSize,Out,MinMatchLen,1<<HashSizeLog);
      if( (x=write_f( Out, OutSize)) != OutSize )            goto Error;
    }
  }
Ok:    delete Out; delete In; return 0;   	 //   
Error: delete Out; delete In; return x<0? x:-1;  //     `x`  /  ,   
}


/*-------------------------------------------------*/
/*   LZP_METHOD                    */
/*-------------------------------------------------*/

// ,       
LZP_METHOD::LZP_METHOD()
{
  BlockSize   = 8*mb;
  MinMatchLen = 64;
  HashSizeLog = 18;
}

//  
int LZP_METHOD::decompress (INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  return lzp_decompress (BlockSize, MinMatchLen, HashSizeLog, read_f, write_f);
}

#ifndef FREEARC_DECOMPRESS_ONLY

//  
int LZP_METHOD::compress (INOUT_FUNC *read_f, INOUT_FUNC *write_f)
{
  return lzp_compress   (BlockSize, MinMatchLen, HashSizeLog, read_f, write_f);
}

//   buf[MAX_METHOD_STRLEN] ,       (,   parse_LZP)
void LZP_METHOD::ShowCompressionMethod (char *buf)
{
  char BlockSizeStr[100];
  showMem (BlockSize, BlockSizeStr);
  sprintf (buf, "lzp:%s:l%d:h%d", BlockSizeStr, MinMatchLen, HashSizeLog);
}

#endif  // !defined (FREEARC_DECOMPRESS_ONLY)

//    LZP_METHOD    
//   NULL,          
COMPRESSION_METHOD* parse_LZP (char** parameters)
{
  if (strcmp (parameters[0], "lzp") == 0) {
    //    ( ) - "lzp",    

    LZP_METHOD *p = new LZP_METHOD;
    int error = 0;  //  ,      

    //     (         )
    while (*++parameters && !error)
    {
      char* param = *parameters;
      switch (*param) {                    // ,  
        case 'b':  p->BlockSize   = parseMem (param+1, &error); continue;
        case 'l':  p->MinMatchLen = parseInt (param+1, &error); continue;
        case 'h':  p->HashSizeLog = parseInt (param+1, &error); continue;
      }
      //   ,       
      //         (..   -  ),
      //      MinMatchLen,      BlockSize
      int n = parseInt (param, &error);
      if (!error) p->MinMatchLen = n;
      else        error=0, p->BlockSize = parseMem (param, &error);
    }
    if (error)  {delete p; return NULL;}  //     
    return p;
  } else
    return NULL;   //    lzp
}

static int LZP_x = AddCompressionMethod (parse_LZP);   //    LZP
