#include "../Compression.h"

int lzp_compress   (int BlockSize, int MinMatchLen,int HashSizeLog, INOUT_FUNC *read_f, INOUT_FUNC *write_f);
int lzp_decompress (int BlockSize, int MinMatchLen,int HashSizeLog, INOUT_FUNC *read_f, INOUT_FUNC *write_f);


#ifdef __cplusplus

//  ⠭⭮ 䥩 ⮤ ᦠ COMPRESSION_METHOD
class LZP_METHOD : public COMPRESSION_METHOD
{
public:
  // ࠬ ⮣ ⮤ ᦠ
  int BlockSize;
  int MinMatchLen;
  int HashSizeLog;

  // , ᢠ騩 ࠬࠬ ⮤ ᦠ 祭  㬮砭
  LZP_METHOD();

  // 㭪樨 ᯠ  㯠
  virtual int decompress (INOUT_FUNC *read_f, INOUT_FUNC *write_f);
#ifndef FREEARC_DECOMPRESS_ONLY
  virtual int compress   (INOUT_FUNC *read_f, INOUT_FUNC *write_f);

  //   buf[MAX_METHOD_STRLEN] ப, 뢠 ⮤ ᦠ   ࠬ (㭪, ⭠  parse_LZP)
  virtual void ShowCompressionMethod (char *buf);

  // /⠭  , ᯮ㥬  㯠/ᯠ, ࠧ ᫮  ࠧ 
  virtual int  GetCompressionMem     (void)     {return BlockSize*2;}
  virtual int  GetDecompressionMem   (void)     {return BlockSize*2;}
  virtual int  GetDictionary         (void)     {return BlockSize;}
  virtual int  GetBlockSize          (void)     {return BlockSize;}
  virtual void SetCompressionMem     (int mem)  {if (mem>0)   BlockSize = mem/2;}
  virtual void SetDecompressionMem   (int mem)  {if (mem>0)   BlockSize = mem/2;}
  virtual void SetDictionary         (int dict) {if (dict>0)  BlockSize = dict;}
  virtual void SetBlockSize          (int bs)   {if (bs>0)    BlockSize = bs;}
#endif
};

// 騪 ப ⮤ ᦠ LZP
COMPRESSION_METHOD* parse_LZP (char** parameters);

#endif  // __cplusplus
