#include "../Compression.h"

int ppmd_compress   (int order, int mem, int MRMethod, INOUT_FUNC *read_f, INOUT_FUNC *write_f);
int ppmd_decompress (int order, int mem, int MRMethod, INOUT_FUNC *read_f, INOUT_FUNC *write_f);


#ifdef __cplusplus

//      COMPRESSION_METHOD
class PPMD_METHOD : public COMPRESSION_METHOD
{
public:
  //    
  int order;
  int mem;
  int MRMethod;

  // ,       
  PPMD_METHOD();

  //    
  virtual int decompress (INOUT_FUNC *read_f, INOUT_FUNC *write_f);
#ifndef FREEARC_DECOMPRESS_ONLY
  virtual int compress (INOUT_FUNC *read_f, INOUT_FUNC *write_f);

  //   buf[MAX_METHOD_STRLEN] ,       (,   parse_PPMD)
  virtual void ShowCompressionMethod (char *buf);

  // /  ,   /,     
  virtual int  GetCompressionMem     (void)     {return mem;}
  virtual int  GetDecompressionMem   (void)     {return mem;}
  virtual int  GetDictionary         (void)     {return 0;}
  virtual int  GetBlockSize          (void)     {return 0;}
  virtual void SetCompressionMem     (int _mem) {if (_mem>0)  mem = _mem;}
  virtual void SetDecompressionMem   (int _mem) {if (_mem>0)  mem = _mem;}
  virtual void SetDictionary         (int)      {}
  virtual void SetBlockSize          (int)      {}
#endif
};

//     PPMD
COMPRESSION_METHOD* parse_PPMD (char** parameters);

#endif  // __cplusplus
